using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Threading;
using System.Diagnostics;
using System.IO;
using System.Text;
using System.Runtime.InteropServices;
using EnvDTE;
using SVNCOM;

namespace SVN_NET
{
	/// <summary>
	/// Summary description for StatusForm.
	/// </summary>
	public class StatusForm : System.Windows.Forms.Form
	{
		[DllImport("shlwapi.dll")]
		public static extern bool PathCompactPathEx(StringBuilder dest, string src, int cchMax, int flags);
	

		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.Label label7;
		private System.Windows.Forms.Label label8;
		private System.Windows.Forms.Label label9;
		private System.Windows.Forms.Label label10;
		private System.Windows.Forms.Label label11;
		private System.Windows.Forms.Label label12;
		private System.Windows.Forms.Label label13;
		private System.Windows.Forms.Label label14;
		private System.Windows.Forms.Label label15;
		private System.Windows.Forms.Label label17;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label nameLabel;
		private System.Windows.Forms.Label revisionLabel;
		private System.Windows.Forms.Label urlLabel;
		private System.Windows.Forms.Label repositoryLabel;
		private System.Windows.Forms.Label scheduleLabel;
		private System.Windows.Forms.Label lockedLabel;
		private System.Windows.Forms.Label copiedLabel;
		private System.Windows.Forms.Label crevisionLabel;
		private System.Windows.Forms.Label cdateLabel;
		private System.Windows.Forms.Label cauthorLabel;
		private System.Windows.Forms.Label texttimeLabel;
		private System.Windows.Forms.Label propertytimeLabel;
		private System.Windows.Forms.Label textstatusLabel;
		private System.Windows.Forms.Label propertystatusLabel;
		private System.Windows.Forms.Label textstatusrepLabel;
		private System.Windows.Forms.Label propertystatusrepoLabel;
		private System.Windows.Forms.Button okButton;
		private System.Windows.Forms.Button updateButton;

		private string statuspath;

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public StatusForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.label1 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.label4 = new System.Windows.Forms.Label();
			this.label5 = new System.Windows.Forms.Label();
			this.label6 = new System.Windows.Forms.Label();
			this.label7 = new System.Windows.Forms.Label();
			this.label8 = new System.Windows.Forms.Label();
			this.label9 = new System.Windows.Forms.Label();
			this.label10 = new System.Windows.Forms.Label();
			this.label11 = new System.Windows.Forms.Label();
			this.label12 = new System.Windows.Forms.Label();
			this.label13 = new System.Windows.Forms.Label();
			this.label14 = new System.Windows.Forms.Label();
			this.label15 = new System.Windows.Forms.Label();
			this.label17 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.nameLabel = new System.Windows.Forms.Label();
			this.revisionLabel = new System.Windows.Forms.Label();
			this.urlLabel = new System.Windows.Forms.Label();
			this.repositoryLabel = new System.Windows.Forms.Label();
			this.scheduleLabel = new System.Windows.Forms.Label();
			this.lockedLabel = new System.Windows.Forms.Label();
			this.copiedLabel = new System.Windows.Forms.Label();
			this.crevisionLabel = new System.Windows.Forms.Label();
			this.cdateLabel = new System.Windows.Forms.Label();
			this.cauthorLabel = new System.Windows.Forms.Label();
			this.texttimeLabel = new System.Windows.Forms.Label();
			this.propertytimeLabel = new System.Windows.Forms.Label();
			this.textstatusLabel = new System.Windows.Forms.Label();
			this.propertystatusLabel = new System.Windows.Forms.Label();
			this.textstatusrepLabel = new System.Windows.Forms.Label();
			this.propertystatusrepoLabel = new System.Windows.Forms.Label();
			this.okButton = new System.Windows.Forms.Button();
			this.updateButton = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 8);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(56, 16);
			this.label1.TabIndex = 0;
			this.label1.Text = "Name:";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(8, 32);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(56, 16);
			this.label3.TabIndex = 2;
			this.label3.Text = "Revision:";
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(8, 80);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(64, 16);
			this.label4.TabIndex = 3;
			this.label4.Text = "Repository:";
			// 
			// label5
			// 
			this.label5.Location = new System.Drawing.Point(8, 104);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(56, 16);
			this.label5.TabIndex = 4;
			this.label5.Text = "Schedule:";
			// 
			// label6
			// 
			this.label6.Location = new System.Drawing.Point(8, 128);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(100, 16);
			this.label6.TabIndex = 5;
			this.label6.Text = "commit revision:";
			// 
			// label7
			// 
			this.label7.Location = new System.Drawing.Point(8, 224);
			this.label7.Name = "label7";
			this.label7.Size = new System.Drawing.Size(80, 16);
			this.label7.TabIndex = 6;
			this.label7.Text = "property time:";
			// 
			// label8
			// 
			this.label8.Location = new System.Drawing.Point(8, 56);
			this.label8.Name = "label8";
			this.label8.Size = new System.Drawing.Size(56, 16);
			this.label8.TabIndex = 7;
			this.label8.Text = "URL:";
			// 
			// label9
			// 
			this.label9.Location = new System.Drawing.Point(8, 176);
			this.label9.Name = "label9";
			this.label9.Size = new System.Drawing.Size(80, 16);
			this.label9.TabIndex = 8;
			this.label9.Text = "commit author:";
			// 
			// label10
			// 
			this.label10.Location = new System.Drawing.Point(8, 152);
			this.label10.Name = "label10";
			this.label10.Size = new System.Drawing.Size(72, 16);
			this.label10.TabIndex = 9;
			this.label10.Text = "commit date:";
			// 
			// label11
			// 
			this.label11.Location = new System.Drawing.Point(8, 200);
			this.label11.Name = "label11";
			this.label11.Size = new System.Drawing.Size(64, 16);
			this.label11.TabIndex = 10;
			this.label11.Text = "text time:";
			// 
			// label12
			// 
			this.label12.Location = new System.Drawing.Point(224, 248);
			this.label12.Name = "label12";
			this.label12.Size = new System.Drawing.Size(128, 16);
			this.label12.TabIndex = 12;
			this.label12.Text = "text status in repository:";
			// 
			// label13
			// 
			this.label13.Location = new System.Drawing.Point(224, 272);
			this.label13.Name = "label13";
			this.label13.Size = new System.Drawing.Size(152, 16);
			this.label13.TabIndex = 13;
			this.label13.Text = "property status in repository:";
			// 
			// label14
			// 
			this.label14.Location = new System.Drawing.Point(8, 272);
			this.label14.Name = "label14";
			this.label14.Size = new System.Drawing.Size(88, 16);
			this.label14.TabIndex = 14;
			this.label14.Text = "property status:";
			// 
			// label15
			// 
			this.label15.Location = new System.Drawing.Point(368, 104);
			this.label15.Name = "label15";
			this.label15.Size = new System.Drawing.Size(48, 16);
			this.label15.TabIndex = 15;
			this.label15.Text = "copied:";
			// 
			// label17
			// 
			this.label17.Location = new System.Drawing.Point(264, 104);
			this.label17.Name = "label17";
			this.label17.Size = new System.Drawing.Size(48, 16);
			this.label17.TabIndex = 17;
			this.label17.Text = "locked:";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(8, 248);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(64, 16);
			this.label2.TabIndex = 18;
			this.label2.Text = "text status:";
			// 
			// nameLabel
			// 
			this.nameLabel.Location = new System.Drawing.Point(80, 8);
			this.nameLabel.Name = "nameLabel";
			this.nameLabel.Size = new System.Drawing.Size(376, 16);
			this.nameLabel.TabIndex = 19;
			// 
			// revisionLabel
			// 
			this.revisionLabel.Location = new System.Drawing.Point(80, 32);
			this.revisionLabel.Name = "revisionLabel";
			this.revisionLabel.Size = new System.Drawing.Size(376, 16);
			this.revisionLabel.TabIndex = 20;
			// 
			// urlLabel
			// 
			this.urlLabel.Location = new System.Drawing.Point(80, 56);
			this.urlLabel.Name = "urlLabel";
			this.urlLabel.Size = new System.Drawing.Size(376, 16);
			this.urlLabel.TabIndex = 21;
			// 
			// repositoryLabel
			// 
			this.repositoryLabel.Location = new System.Drawing.Point(80, 80);
			this.repositoryLabel.Name = "repositoryLabel";
			this.repositoryLabel.Size = new System.Drawing.Size(376, 16);
			this.repositoryLabel.TabIndex = 22;
			// 
			// scheduleLabel
			// 
			this.scheduleLabel.Location = new System.Drawing.Point(80, 104);
			this.scheduleLabel.Name = "scheduleLabel";
			this.scheduleLabel.Size = new System.Drawing.Size(128, 16);
			this.scheduleLabel.TabIndex = 23;
			// 
			// lockedLabel
			// 
			this.lockedLabel.Location = new System.Drawing.Point(312, 104);
			this.lockedLabel.Name = "lockedLabel";
			this.lockedLabel.Size = new System.Drawing.Size(48, 16);
			this.lockedLabel.TabIndex = 24;
			// 
			// copiedLabel
			// 
			this.copiedLabel.Location = new System.Drawing.Point(416, 104);
			this.copiedLabel.Name = "copiedLabel";
			this.copiedLabel.Size = new System.Drawing.Size(40, 16);
			this.copiedLabel.TabIndex = 25;
			// 
			// crevisionLabel
			// 
			this.crevisionLabel.Location = new System.Drawing.Point(128, 128);
			this.crevisionLabel.Name = "crevisionLabel";
			this.crevisionLabel.Size = new System.Drawing.Size(224, 16);
			this.crevisionLabel.TabIndex = 26;
			// 
			// cdateLabel
			// 
			this.cdateLabel.Location = new System.Drawing.Point(128, 152);
			this.cdateLabel.Name = "cdateLabel";
			this.cdateLabel.Size = new System.Drawing.Size(328, 16);
			this.cdateLabel.TabIndex = 27;
			// 
			// cauthorLabel
			// 
			this.cauthorLabel.Location = new System.Drawing.Point(128, 176);
			this.cauthorLabel.Name = "cauthorLabel";
			this.cauthorLabel.Size = new System.Drawing.Size(328, 16);
			this.cauthorLabel.TabIndex = 28;
			// 
			// texttimeLabel
			// 
			this.texttimeLabel.Location = new System.Drawing.Point(128, 200);
			this.texttimeLabel.Name = "texttimeLabel";
			this.texttimeLabel.Size = new System.Drawing.Size(328, 16);
			this.texttimeLabel.TabIndex = 29;
			// 
			// propertytimeLabel
			// 
			this.propertytimeLabel.Location = new System.Drawing.Point(128, 224);
			this.propertytimeLabel.Name = "propertytimeLabel";
			this.propertytimeLabel.Size = new System.Drawing.Size(328, 16);
			this.propertytimeLabel.TabIndex = 30;
			// 
			// textstatusLabel
			// 
			this.textstatusLabel.Location = new System.Drawing.Point(128, 248);
			this.textstatusLabel.Name = "textstatusLabel";
			this.textstatusLabel.Size = new System.Drawing.Size(88, 16);
			this.textstatusLabel.TabIndex = 31;
			// 
			// propertystatusLabel
			// 
			this.propertystatusLabel.Location = new System.Drawing.Point(128, 272);
			this.propertystatusLabel.Name = "propertystatusLabel";
			this.propertystatusLabel.Size = new System.Drawing.Size(80, 16);
			this.propertystatusLabel.TabIndex = 32;
			// 
			// textstatusrepLabel
			// 
			this.textstatusrepLabel.Location = new System.Drawing.Point(376, 248);
			this.textstatusrepLabel.Name = "textstatusrepLabel";
			this.textstatusrepLabel.Size = new System.Drawing.Size(100, 16);
			this.textstatusrepLabel.TabIndex = 33;
			// 
			// propertystatusrepoLabel
			// 
			this.propertystatusrepoLabel.Location = new System.Drawing.Point(376, 272);
			this.propertystatusrepoLabel.Name = "propertystatusrepoLabel";
			this.propertystatusrepoLabel.Size = new System.Drawing.Size(100, 16);
			this.propertystatusrepoLabel.TabIndex = 34;
			// 
			// okButton
			// 
			this.okButton.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.okButton.Location = new System.Drawing.Point(392, 304);
			this.okButton.Name = "okButton";
			this.okButton.TabIndex = 35;
			this.okButton.Text = "OK";
			// 
			// updateButton
			// 
			this.updateButton.Location = new System.Drawing.Point(240, 304);
			this.updateButton.Name = "updateButton";
			this.updateButton.Size = new System.Drawing.Size(136, 23);
			this.updateButton.TabIndex = 36;
			this.updateButton.Text = "update with repository";
			this.updateButton.Click += new System.EventHandler(this.updateButton_Click);
			// 
			// StatusForm
			// 
			this.AcceptButton = this.okButton;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(480, 334);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.updateButton,
																		  this.okButton,
																		  this.propertystatusrepoLabel,
																		  this.textstatusrepLabel,
																		  this.propertystatusLabel,
																		  this.textstatusLabel,
																		  this.propertytimeLabel,
																		  this.texttimeLabel,
																		  this.cauthorLabel,
																		  this.cdateLabel,
																		  this.crevisionLabel,
																		  this.copiedLabel,
																		  this.lockedLabel,
																		  this.scheduleLabel,
																		  this.repositoryLabel,
																		  this.urlLabel,
																		  this.revisionLabel,
																		  this.nameLabel,
																		  this.label2,
																		  this.label17,
																		  this.label15,
																		  this.label14,
																		  this.label13,
																		  this.label12,
																		  this.label11,
																		  this.label10,
																		  this.label9,
																		  this.label8,
																		  this.label7,
																		  this.label6,
																		  this.label5,
																		  this.label4,
																		  this.label3,
																		  this.label1});
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.MaximizeBox = false;
			this.Name = "StatusForm";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "StatusForm";
			this.ResumeLayout(false);

		}
		#endregion

		private void updateButton_Click(object sender, System.EventArgs e)
		{
			SVNCOM.SVN svn = new SVNCOM.SVN();
			SVNCOM.SVNStatusClass svnstatus = (SVNCOM.SVNStatusClass)svn.GetFileStatus(true, statuspath);
			FillStatusLabels(svnstatus);
		}

		public void SetPath(string path)
		{
			statuspath = path;
			SVNCOM.SVN svn = new SVNCOM.SVN();
			SVNCOM.SVNStatusClass svnstatus = (SVNCOM.SVNStatusClass)svn.GetFileStatus(false, statuspath);
			FillStatusLabels(svnstatus);
		}

		private void FillStatusLabels(SVNCOM.SVNStatusClass svnstatus)
		{
			nameLabel.Text = svnstatus.name;
			revisionLabel.Text = svnstatus.revision.ToString();

			StringBuilder temp = new StringBuilder(70);
			PathCompactPathEx(temp, svnstatus.url, 70, 0);
			urlLabel.Text = temp.ToString();

			repositoryLabel.Text = svnstatus.repository;
			scheduleLabel.Text = GetScheduleString(svnstatus.schedule);
			lockedLabel.Text = svnstatus.locked ? "yes" : "no";
			if (svnstatus.locked)
				lockedLabel.ForeColor = System.Drawing.Color.Red;
			else
				lockedLabel.ForeColor = System.Drawing.Color.Black;
			copiedLabel.Text = svnstatus.copied ? "yes" : "no";
			crevisionLabel.Text = svnstatus.cmt_rev.ToString();
			cdateLabel.Text = svnstatus.cmt_date.ToShortTimeString()+" "+svnstatus.cmt_date.ToShortDateString();
			cauthorLabel.Text = svnstatus.cmt_author;
			texttimeLabel.Text = svnstatus.text_time.ToShortTimeString()+" "+svnstatus.text_time.ToShortDateString();
			propertytimeLabel.Text = svnstatus.prop_time.ToShortTimeString()+" "+svnstatus.prop_time.ToShortDateString();
			textstatusLabel.Text = GetStatusString(svnstatus.text_status);
			propertystatusLabel.Text = GetStatusString(svnstatus.prop_status);
			textstatusrepLabel.Text = GetStatusString(svnstatus.repos_text_status);
			propertystatusrepoLabel.Text = GetStatusString(svnstatus.repos_prop_status);
		}

		public static string GetScheduleString(SVNCOM.svn_schedule schedule)
		{
			switch (schedule)
			{
				case SVNCOM.svn_schedule.schedule_normal:
					return "normal";
				case SVNCOM.svn_schedule.schedule_add:
					return "add";
				case SVNCOM.svn_schedule.schedule_delete:
					return "delete";
				case SVNCOM.svn_schedule.schedule_replace:
					return "replace";
				default:
					return "";
			}
		}
		public static string GetStatusString(SVNCOM.svn_statuses status)
		{
			switch (status)
			{
				case SVNCOM.svn_statuses.status_none:
					return "none";
				case SVNCOM.svn_statuses.status_unversioned:
					return "unversioned";
				case SVNCOM.svn_statuses.status_normal:
					return "normal";
				case SVNCOM.svn_statuses.status_added:
					return "added";
				case SVNCOM.svn_statuses.status_absent:
					return "absent";
				case SVNCOM.svn_statuses.status_deleted:
					return "deleted";
				case SVNCOM.svn_statuses.status_replaced:
					return "replaced";
				case SVNCOM.svn_statuses.status_modified:
					return "modified";
				case SVNCOM.svn_statuses.status_merged:
					return "merged";
				case SVNCOM.svn_statuses.status_conflicted:
					return "conflicted";
				case SVNCOM.svn_statuses.status_obstructed:
					return "obstructed";
				default:
					return "";
			}
		}
	}
}
